
float4x4 mWVP;  // ǥ ->  ǥ
float4x4 mWVT; 
float4x4 mWVI; 
float4 vLight;
float4 vCamer;
float4 cAmbient;
float4 cSpeculra;
float4 cDiff;
float4 vPower;

texture BaseTex;

float4x4 mWV;
float4x4 mP; 
float4 GlowColor;
float4 GlowAmbient;
float GlowThickness;

float4 vViewPosition;
float vVR;

sampler2D BaseSamp = sampler_state
{
  Texture = <BaseTex>;
  MinFilter = LINEAR;
  MagFilter = LINEAR;
  MipFilter = NONE;

  AddressU = Clamp;
  AddressV = Clamp;
};

texture NormalTex;
sampler2D NormalSamp = sampler_state
{
  Texture = <NormalTex>;
  MinFilter = LINEAR;
  MagFilter = LINEAR;
  MipFilter = NONE;

  AddressU = Clamp;
  AddressV = Clamp;
};

texture GlossTex;
sampler2D GlossSamp = sampler_state
{
  Texture = <GlossTex>;
  MinFilter = LINEAR;
  MagFilter = LINEAR;
  MipFilter = NONE;

  AddressU = Clamp;
  AddressV = Clamp;
};

texture AemTex;
sampler2D AemSamp = sampler_state
{
  Texture = <AemTex>;
  MinFilter = LINEAR;
  MagFilter = LINEAR;
  MipFilter = NONE;

  AddressU = Clamp;
  AddressV = Clamp;
};

texture CUBETex;
samplerCUBE CUBESamp = sampler_state
{
  Texture = <CUBETex>;
  MinFilter = LINEAR;
  MagFilter = LINEAR;
  MipFilter = NONE;

  AddressU = Clamp;
  AddressV = Clamp;
};


struct VS_OUTPUT_BASE
{
  float4 Pos  :  POSITION;  //ġ
  float2 Tex  :  TEXCOORD0; //ؽ uv
  float3 View :  TEXCOORD1; //ī޶ ġ
  float3 Light : TEXCOORD2; // ġ
  float3 Normal : TEXCOORD3; //븻 
};


// ̴
VS_OUTPUT_BASE VS_BASE(
	     float4 Pos : POSITION,
	     float3 Nor : NORMAL,
	     float2 Tex : TEXCOORD
	     )	     
{
   float4 ObjectPos=float4(0,0,0,0);   
   float3 ViewD=float3(0,0,0);
   float3 LightD=float3(0,0,0);
   float4 Tangent=float4(0,0,0,0);
   float4 Binormal=float4(0,0,0,0);
   float4 Normal=float4(0,0,0,0);
   
   VS_OUTPUT_BASE Out = (VS_OUTPUT_BASE)0;
   
   Out.Pos = mul(Pos,mWVP);
   Out.Tex = Tex;
   ObjectPos = mul(Pos,mWVT);
   ViewD = vCamer - ObjectPos;
   LightD = vLight - ObjectPos;   

   Normal = mul(Nor,mWVI);

   Out.View = ViewD;
   Out.Light = LightD;	
   Out.Normal = Normal;

   return Out;
}

struct PS_INPUT_BASE
{
	float2 Tex : TEXCOORD0;
	float3 View : TEXCOORD1;
	float3 Light : TEXCOORD2;
};

float4 PS_BASE(VS_OUTPUT_BASE In) : COLOR
{
   float3 fvLightDirection = normalize( In.Light );
   float3 fvNormal         = normalize( In.Normal );
   float  fNDotL           = dot( fvNormal, fvLightDirection ); 
   
   float3 fvReflection     = normalize( (  2.0f *  fNDotL * fvNormal   ) - fvLightDirection ); 
   float3 fvViewDirection  = normalize( In.View );
   float  fRDotV           = max( 0.0f, dot( fvReflection, fvViewDirection ) );
   
   float4 fvBaseColor      = tex2D( BaseSamp, In.Tex );

   float4 fvTotalAmbient   = cAmbient ; 
   float4 fvTotalDiffuse   = cDiff * fNDotL * fvBaseColor; 
   float4 fvTotalSpecular  = cSpeculra * pow( fRDotV, 50 );
   
   //return( saturate( fvTotalAmbient + fvTotalDiffuse + fvTotalSpecular ) );
   return fvBaseColor;
	
}


float4 PS_BASE2(VS_OUTPUT_BASE In) : COLOR
{
   float3 fvLightDirection = normalize( In.Light );
   float3 fvNormal         = normalize( In.Normal );
   float  fNDotL           = dot( fvNormal, fvLightDirection ); 
   
   float3 fvReflection     = normalize( (  2.0f *  fNDotL * fvNormal   ) - fvLightDirection ); 
   float3 fvViewDirection  = normalize( In.View );
   float  fRDotV           = max( 0.0f, dot( fvReflection, fvViewDirection ) );
   
   float4 fvBaseColor      = tex2D( BaseSamp, In.Tex );

   float4 fvTotalAmbient   = cAmbient ; 
   float4 fvTotalDiffuse   = cDiff * fNDotL * fvBaseColor; 
   float4 fvTotalSpecular  = cSpeculra * pow( fRDotV, 50 );
   
   return( saturate( fvTotalAmbient + fvTotalDiffuse + fvTotalSpecular ) );
	
}
struct VS_INPUT_Reflection 
{
   float4 Position : POSITION0;
   
};

struct VS_OUTPUT_Reflection 
{
   float4 Position : POSITION0;
   float3 Texcoord : TEXCOORD0;
   
};

VS_OUTPUT_Reflection vs_main_Reflection( VS_INPUT_Reflection Input )
{
   VS_OUTPUT_Reflection Output;

   Output.Position = mul( float4(Input.Position.xyz + vViewPosition.xyz, 1), 
                              mWVP );
   Output.Texcoord = Input.Position.xyz;
   
   return( Output );
   
}

struct PS_INPUT_Reflection 
{
   float3 Texcoord : TEXCOORD0;  
};

float4 ps_main_Reflection(PS_INPUT_Reflection Input) : COLOR0
{   
   
   return( texCUBE(CUBESamp, Input.Texcoord));
   
}

struct VS_INPUT_RM {
   float4 Position : POSITION0;
   float3 Normal   : NORMAL;
};
struct VS_OUTPUT_RM {
   float4 Position : POSITION0;
   float3 Texcoord : TEXCOORD0;
};

VS_OUTPUT_RM vs_main_RM( VS_INPUT_RM Input ){
   VS_OUTPUT_RM Output;
   Output.Position = mul( Input.Position, mWVP );  
	float3 Eye = normalize(vViewPosition - Input.Position); //Local or World
   float3 Refraction = normalize(vVR * dot(Input.Normal,Eye) * Input.Normal - Eye);
   
   Output.Texcoord = Refraction;
   
   return( Output );  
}

struct PS_INPUT_RM {
   float3 Texcoord : TEXCOORD0;
};

float4 ps_main_RM(PS_INPUT_RM Input) : COLOR0
{   
   return( texCUBE(CUBESamp, Input.Texcoord) );
   
}

struct VS_INPUT_GLOW  
{
   float4 Position : POSITION0;
   float3 Normal   : NORMAL;
      
};

struct VS_OUTPUT_GLOW 
{
   float4 Position : POSITION0;
   float4 Diffuse  : COLOR;
};

VS_OUTPUT_GLOW vs_main( VS_INPUT_GLOW Input )
{
   VS_OUTPUT_GLOW Output;
   
   // N Normalize
   float3 N = normalize( mul(Input.Normal, (float3x3)mWV));
   
   // Displace Position
   float3 P = mul(Input.Position, mWV) + GlowThickness * N;
   
   // Glow Axis
   float3 A =  float3(0.0f, 0.0f, 1.0f);
   
   // Power = (1 - ( n dot a) ^2 ) ^2
   float  Power;
   Power  = dot(N, A);
   Power *= Power;
   Power -= 1;
   Power *= Power;
   
   Output.Position = mul( float4(P, 1), mP );
   Output.Diffuse  = GlowColor * Power + GlowAmbient;
   
   return( Output );
   
}

struct PS_INPUT_GLOW
{
   float4 Diffuse : COLOR;
};

float4 ps_main(PS_INPUT_GLOW Input) : COLOR0
{   
   return( Input.Diffuse);
   
}

// ̴ -> ȼ ̴ ѱ
struct VS_OUTPUT
{
  float4 Pos  :  POSITION;  //ġ
  float2 Tex  :  TEXCOORD0; //ؽ uv
  float3 View :  TEXCOORD1; //ī޶ ġ
  float3 Light : TEXCOORD2; // ġ
};


// ̴
VS_OUTPUT VS(
		 float4 Pos : POSITION,
	     float3 Tan : TANGENT,
	     float3 Binor : BINORMAL,
	     float3 Nor : NORMAL,
	     float2 Tex : TEXCOORD
	     )	     
{
   float4 ObjectPos=float4(0,0,0,0);   
   float3 ViewD=float3(0,0,0);
   float3 LightD=float3(0,0,0);
   float4 Tangent=float4(0,0,0,0);
   float4 Binormal=float4(0,0,0,0);
   float4 Normal=float4(0,0,0,0);
   
   VS_OUTPUT Out = (VS_OUTPUT)0;


   
   Out.Pos = mul(Pos,mWVP);
   Out.Tex = Tex;
   ObjectPos = mul(Pos,mWVT);
   ViewD = vCamer - ObjectPos;
   LightD = vLight - ObjectPos;
   
   Tangent = mul(Tan,mWVI);
   Binormal = mul(Binor,mWVI);
   Normal = mul(Nor,mWVI);

   Out.View.x = dot(Tangent,ViewD);
   Out.View.y = dot(Binormal,ViewD);
   Out.View.z = dot(Normal,ViewD);

   Out.Light.x = dot(Tangent,LightD);
   Out.Light.y = dot(Binormal,LightD);
   Out.Light.z = dot(Normal,LightD);	

   return Out;
}

struct PS_INPUT
{
	float2 Tex : TEXCOORD0;
	float3 View : TEXCOORD1;
	float3 Light : TEXCOORD2;
};

float4 PSS(VS_OUTPUT In) : COLOR
{
	float4 Base = tex2D(BaseSamp, In.Tex);
	float4 Bump = tex2D(NormalSamp, In.Tex);
	float4 Gloss = tex2D(GlossSamp, In.Tex);
	float4 Ames = tex2D(AemSamp, In.Tex);
	
	float3 N =Bump * 2;
	N =  N - 1;
	N = normalize(N);
	float3 Lightst=float3(0,0,0);
	Lightst = normalize(In.Light);	
	
	float2 bb=float2(0,0);
	bb.x = dot(N,Lightst);
	
	float3 Ref=float3(0,0,0);
	Ref = N * 2 * bb.x - Lightst;
	Ref = normalize(Ref);
	float3 View =float3(0,0,0);
	View = normalize(In.View);
	bb.y = dot(Ref,View);
	bb.y = max(bb.y,0);

	bb.y = pow(bb.y,30);
	Ames = Ames * cAmbient;
	float4 Temp = bb.x * cDiff;
	Temp = Temp * Base;// - Ames;
	float4 Temp2 = cSpeculra * bb.y;
	
	float4 GetColor = Temp2 * Gloss + Temp;	
	//return Ames;
	return saturate(GetColor);  //saturate 0~1 ̰ ȯ
}

technique TShader
{
    pass P0
    {
        VertexShader = compile vs_2_0 VS();
        PixelShader  = compile ps_2_0 PSS();
    }
    pass P1
    {
        VertexShader = compile vs_2_0 vs_main();
        PixelShader  = compile ps_2_0 ps_main();
				// ø 
		CullMode = CCW;
		  
		//   Ȱȭ
		AlphaBlendEnable = TRUE;
		SrcBlend   = ONE;
		DestBlend        = ONE; 
    }
    pass P2
    {
        VertexShader = compile vs_2_0 vs_main_Reflection();
        PixelShader  = compile ps_2_0 ps_main_Reflection();
				// ø 
		CullMode = CW;	
		ZEnable = FALSE;
    }
    pass P3
    {
        VertexShader = compile vs_2_0 vs_main_RM();
        PixelShader  = compile ps_2_0 ps_main_RM();
				// ø 
		CullMode = CCW;	
		ZEnable = TRUE;
    }
     pass P4
    {
        VertexShader = compile vs_2_0 VS_BASE();
        PixelShader  = compile ps_2_0 PS_BASE();
    }
      pass P5
    {
        VertexShader = compile vs_2_0 VS_BASE();
        PixelShader  = compile ps_2_0 PS_BASE2();
    }
    
     
}